
/* * * * * * * * * * * * * Author's note * * * * * * * * * * * *\
*   _       _   _       _   _       _   _       _     _ _ _ _   *
*  |_|     |_| |_|     |_| |_|_   _|_| |_|     |_|  _|_|_|_|_|  *
*  |_|_ _ _|_| |_|     |_| |_|_|_|_|_| |_|     |_| |_|_ _ _     *
*  |_|_|_|_|_| |_|     |_| |_| |_| |_| |_|     |_|   |_|_|_|_   *
*  |_|     |_| |_|_ _ _|_| |_|     |_| |_|_ _ _|_|  _ _ _ _|_|  *
*  |_|     |_|   |_|_|_|   |_|     |_|   |_|_|_|   |_|_|_|_|    *
*                                                               *
*                     http://www.humus.name                     *
*                                                                *
* This file is a part of the work done by Humus. You are free to   *
* use the code in any way you like, modified, unmodified or copied   *
* into your own work. However, I expect you to respect these points:  *
*  - If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  - For use in anything commercial, please request my approval.     *
*  - Share your work and ideas too as much as you can.             *
*                                                                *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#pragma once

#include "../Platform.h"

// Variable initialization verifier
class RangeChecker
{
public:
	RangeChecker(uint32 *end);
	void Verify(uint32 *end);

private:
	uint32 m_Tag;
};

#ifdef DEBUG

#define CLASS_BEGIN() RangeChecker m_StartTag
#define CLASS_END() uint32 m_EndTag
#define CLASS_INIT() : m_StartTag(&m_EndTag)
#define CLASS_VERIFY() m_StartTag.Verify(&m_EndTag)

#else

#define CLASS_BEGIN()
#define CLASS_END()
#define CLASS_INIT()
#define CLASS_VERIFY()

#endif
