
/* * * * * * * * * * * * * Author's note * * * * * * * * * * * *\
*   _       _   _       _   _       _   _       _     _ _ _ _   *
*  |_|     |_| |_|     |_| |_|_   _|_| |_|     |_|  _|_|_|_|_|  *
*  |_|_ _ _|_| |_|     |_| |_|_|_|_|_| |_|     |_| |_|_ _ _     *
*  |_|_|_|_|_| |_|     |_| |_| |_| |_| |_|     |_|   |_|_|_|_   *
*  |_|     |_| |_|_ _ _|_| |_|     |_| |_|_ _ _|_|  _ _ _ _|_|  *
*  |_|     |_|   |_|_|_|   |_|     |_|   |_|_|_|   |_|_|_|_|    *
*                                                               *
*                     http://www.humus.name                     *
*                                                                *
* This file is a part of the work done by Humus. You are free to   *
* use the code in any way you like, modified, unmodified or copied   *
* into your own work. However, I expect you to respect these points:  *
*  - If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  - For use in anything commercial, please request my approval.     *
*  - Share your work and ideas too as much as you can.             *
*                                                                *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "Label.h"

Label::Label(const float x, const float y, const float w, const float h, const char *txt)
{
	SetPosition(x, y);
	SetSize(w, h);

	m_Text = new char[strlen(txt) + 1];
	strcpy(m_Text, txt);

	m_Enabled = false;
}

Label::~Label()
{
	delete [] m_Text;
}

void Label::Draw(Context context, Primitives &prim, TexFont &font, const SamplerTable linear_clamp, const BlendState blend_src_alpha/*, const DepthState depth_state*/)
{
	ScopeMarker(context, "Label");

	float text_width = 0.75f * m_Size.y;

	float tw = font.GetTextWidth(m_Text);
	float maxW = m_Size.x / tw;
	if (text_width > maxW)
		text_width = maxW;

	font.DrawText(context, m_Position.x, m_Position.y, text_width, m_Size.y, m_Text/*, linearClamp, blendSrcAlpha, depthState*/);
}
