
/* * * * * * * * * * * * * Author's note * * * * * * * * * * * *\
*   _       _   _       _   _       _   _       _     _ _ _ _   *
*  |_|     |_| |_|     |_| |_|_   _|_| |_|     |_|  _|_|_|_|_|  *
*  |_|_ _ _|_| |_|     |_| |_|_|_|_|_| |_|     |_| |_|_ _ _     *
*  |_|_|_|_|_| |_|     |_| |_| |_| |_| |_|     |_|   |_|_|_|_   *
*  |_|     |_| |_|_ _ _|_| |_|     |_| |_|_ _ _|_|  _ _ _ _|_|  *
*  |_|     |_|   |_|_|_|   |_|     |_|   |_|_|_|   |_|_|_|_|    *
*                                                               *
*                     http://www.humus.name                     *
*                                                                *
* This file is a part of the work done by Humus. You are free to   *
* use the code in any way you like, modified, unmodified or copied   *
* into your own work. However, I expect you to respect these points:  *
*  - If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  - For use in anything commercial, please request my approval.     *
*  - Share your work and ideas too as much as you can.             *
*                                                                *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#pragma once

enum ItemType
{
	CONSTANT,
	TEXTURE,
	STRUCTUREDBUFFER,
	RWTEXTURE,
	RWSTRUCTUREDBUFFER,
	CBV,
	SMP,
	RESOURCE_TABLE,
	SAMPLER_TABLE,

	INVALID = -1,
};

struct SVulkanRootSlot
{
	ItemType m_Type;
	uint32   m_Size;
};

struct SVulkanResourceTableItem
{
	ItemType m_Type;
	uint32   m_NumElements;
};

struct SVulkanRoot
{
	uint32 m_NumSlots;
	SVulkanRootSlot m_Slots[1]; // Will actually contain m_NumSlots elements
};